unit PseudoModal;
interface
uses SysUtils,Classes,forms,windows,Messages,Vcl.Controls;

type
  TForm = class(forms.TForm)
  private
   modalform:TCustomForm;
  protected
   procedure CreateParams(var Params:TCreateParams); override;
  public
   function MyShowModal(const ModalCaler:TCustomForm=nil):integer;
   function GetModalCaller:TCustomForm;
   constructor Create(AOwner: TComponent); override;
  end;

implementation

constructor TForm.Create(AOwner: TComponent);
begin
  inherited;
  modalform:=nil;
end;

procedure TForm.CreateParams(var Params: TCreateParams);
begin
 inherited;
 if modalform <> nil then Params.WndParent := modalform.Handle;
end;

function TForm.GetModalCaller: TCustomForm;
begin
 result:=modalform
end;

function TForm.MyShowModal(const ModalCaler:TCustomForm=nil):integer;
var
 ActiveWindow: HWnd;
 p_WINDOW:Forms.TForm;
begin
  if Owner=nil then p_WINDOW:=Screen.ActiveForm else p_WINDOW:=Tform(owner);
  ActiveWindow := GetActiveWindow;
  if ModalCaler<>nil  then modalform:=ModalCaler else modalform:=TForm(p_WINDOW);

  EnableWindow(p_WINDOW.Handle,False);
  ModalResult:=0;
  RecreateWnd;
  Include(FFormState, fsModal);
  Show;
  try
    SendMessage(self.Handle, CM_ACTIVATE, 0, 0);
    repeat
      Application.HandleMessage;
      if (Application.Terminated)or(not visible) then ModalResult:=mrCancel else
      if ModalResult<>0 then begin CloseModal;Break;end
    until ModalResult<>0;
    Result:=ModalResult;
    SendMessage(Handle, CM_DEACTIVATE, 0, 0);
    modalform:=nil;
  finally
    Hide;
  end;
  Exclude(FFormState, fsModal);
  EnableWindow(p_WINDOW.Handle,true);
  if GetActiveWindow=self.Handle then SetActiveWindow(ActiveWindow);
end;

end.
